#include <stdio.h>
#include <stdlib.h>
#include "types.h"
/*****************************************************************************
  Rutina per escriure de la posicio i a la j del vector double v
*****************************************************************************/
void ip_write_double(double *v, int i, int j, char *nom)
{
  int k;
  
  for(k=i; k<=j; k++) printf("%s(%i)= %e\n",nom,k,v[k]); 
}

/*****************************************************************************
  Rutina per escriure de la posicio i a la j del vector int v
*****************************************************************************/
void ip_write_int(int *v, int i, int j, char *nom)
{
  int k;
  
  for(k=i; k<=j; k++) printf("%s(%i)= %i\n",nom,k,v[k]); 
}

/*****************************************************************************
  Rutina auxiliar usada per qsort per comparar el primer camp del typedef
  K_L_ARC
*****************************************************************************/
int ip_comp_camp1(K_L_ARC *i, K_L_ARC *j)
{
  return(i->k - j->k);
}     

/*****************************************************************************
  Rutina auxiliar usada per qsort per comparar el segon camp del typedef
  K_L_ARC
*****************************************************************************/
int ip_comp_camp2(K_L_ARC *i, K_L_ARC *j)
{
  return(i->l - j->l);
}     

/*****************************************************************************
  Rutina per calcular norma 2 al quadrat d'un vector
*****************************************************************************/
double ip_norma2(double *v, int nn)
{
  int i;
  double r;

  for(r=0.0,i=0;i<nn;i++) r += v[i]*v[i];
  return(r);
}     

/*****************************************************************************
  Rutina per fer el producte escalar simple de dos vectors
*****************************************************************************/
double prod_esc(int nn, double *v1, double *v2)
{
  int i;
  double r;

  for(r=0.0,i=0;i<nn;i++) r += v1[i]*v2[i];
  return(r);
}     

/*****************************************************************************
  Rutina per copiar v1=v2 vectors reals
*****************************************************************************/
void dcopia(int nn, double *v1, double *v2)
{
  int i;

  for(i=0;i<nn;i++) v1[i]=v2[i];
}     

/*****************************************************************************
  Rutina per donar l'index i del minim element de vv
*****************************************************************************/
int indmin(int nn, double *vv)
{
  int i,j;
  double min;
  
  j= 0; 
  min= vv[0];
  for(i=1;i<nn;i++) 
    if(vv[i]<min) {
      j=i;
      min= vv[i];
    }
  return(j);
}     

/*****************************************************************************
  Rutina per donar l'index i del maxim element de vv
*****************************************************************************/
int indmax(int nn, double *vv)
{
  int i,j;
  double max;
  
  j= 0; 
  max= vv[0];
  for(i=1;i<nn;i++) 
    if(vv[i]>max) {
      j=i;
      max= vv[i];
    }
  return(j);
}     

